#include "xhbasic.h"
#include "ltrwidth.h"
#include "letter.h"
#include "letters.xpm"
#include <string.h>
#include <stdlib.h>

Pixmap letpm = 0;
Pixmap letmask = 0;

Pixmap lpm[36],lms[36];
TitleLetter::TitleLetter(XhedgehogWin *xw,char c,int mc,int o) :
  Sprite(xw,400 + o,140,0,0) {
    count = 0;
    maxcount = mc;
    val = c;
    if(letpm == 0) {
      xw->LoadPixmap(letters_xpm,&letpm,&letmask);
      int i;
      int p,w;
      for(i=0;i<36;i++) {
	if(i >= 35) {
	  p = 739;
	}
	else {
	  p = LetterPos[i + 1];
	}
	w = p - LetterPos[i];
	int dummy;
	Window dw;
	unsigned int dummy2;
	unsigned int dep,dep2;
	XGetGeometry(xw->theDisplay(),letpm,&dw,&dummy,&dummy,&dummy2,&dummy2,
		     &dummy2,&dep);
	XGetGeometry(xw->theDisplay(),letmask,
		     &dw,&dummy,&dummy,&dummy2,&dummy2,
		     &dummy2,&dep2);
	lpm[i] = XCreatePixmap
	  (xw->theDisplay(),letpm,w,38,
	   dep);
	lms[i] = XCreatePixmap
	  (xw->theDisplay(),letmask,w,38,
	   dep2);
	GC gc,gc2;
	XGCValues gcv;
	gcv.function = GXcopy;
	gcv.graphics_exposures = False;
    
	gc = XCreateGC(host->theDisplay(),
		    letpm,
		    GCGraphicsExposures |
		    GCFunction,&gcv);
	gc2 = XCreateGC(host->theDisplay(),
		    letmask,
		    GCGraphicsExposures |
		    GCFunction,&gcv);

	XCopyArea(xw->theDisplay(),letpm,lpm[i],gc,LetterPos[i],0,w,
		  38,0,0);
	XCopyArea(xw->theDisplay(),letmask,lms[i],gc2,LetterPos[i],0,w,
		  38,0,0);
	XFreeGC(xw->theDisplay(),gc);
	XFreeGC(xw->theDisplay(),gc2);
      }
    }
    ChangeSpriteShape(lpm[c],lms[c]);
    SetSpriteMotion(-50,0);
}

void TitleLetter::MoveSprite(float newx,float newy) {
  count++;
  if(count >= maxcount) {
    if(count >= maxcount + 50) {
      SetSpriteMotion(50,0);
      if(newx >= 400) {
	Nuke();
      }
    }
    else {
      SetSpriteMotion(0,0);
    }
  }
  
  Sprite::MoveSprite(newx,newy);
}

void AnimateString1(XhedgehogWin *xhw,char *str) {
  int len = strlen(str);
  char c;
  int i,o;
  o = 0;
  TitleLetter *t;
  for(i = 0;i < len;i++) {
    if(str[i] >= 'A' && str[i] <= 'Z') {
      c = str[i] - 'A';
    } else
      if(str[i] >= 'a' && str[i] <= 'z') {
	c = str[i] - 'a';
      } else
	if(str[i] >= '0' && str[i] <= '9') {
	  c = str[i] - '0' + 26;
	}
	else {
	  c = 0xff;
	}
    if(c >= 0 && c < 36) {
      new TitleLetter(xhw,c,len / 2,o);
      o += (c == 35 ? 739 : LetterPos[c + 1]) - LetterPos[c] + 1;
    }
    else {
      o += 20;
    }
  }
}
    
