#include "xhbasic.h"
#include "smoke.h"

#include "smoke.xpm"

Pixmap smokepm = 0,smokemsk = 0;

PuffOfSmoke::PuffOfSmoke(XhedgehogWin *xhw,float _x,float _y) :
  ZoneObject(xhw,_x,_y,0,0,4,2)
{
  if(!smokepm) {
    xhw->LoadPixmap(smoke_xpm,&smokepm,&smokemsk);
  }
  ChangeSpriteShape(smokepm,smokemsk);
  auto_animate = 1;
  count = 0;
}

void PuffOfSmoke::MoveSprite(float newx,float newy) {
  ZoneObject::MoveSprite(newx,newy);
  count++;
  if(count > 8) {
    Nuke();
  }
}

